#include <iostream>
#include <deque>

using namespace std;

const int N = 100000;
const int Q = 100000;

double exp_l [N + 10];

double cost (int l, int r) {
  return (double) (r - l + 1) * (exp_l[r] - exp_l[l - 1]) / 2 + N;
}

double dp [N + 10];
int last [N + 10];

int main () {
  for (int i = 1; i <= N; i++) {
    exp_l[i] = 2 * (double) (N - i + 1) / N;
  }

  for (int i = 1; i <= N; i++) {
    exp_l[i] += exp_l[i - 1];
  }

  for (int i = 1; i <= N; i++) {
    dp[i] = 10000000000.0;
  }

  for (int i = 1; i <= N; i++) {
    for (int j = 1; j <= i; j++) {
      double score = dp[j - 1] + cost(j, i);
      if (score < dp[i]) {
        dp[i] = score;
        last[i] = j - 1;
      }
    }
  }

  deque<int> ans;
  for (int i = N; i != 0; i = last[i]) {
    ans.push_front(i);
  }

  cout << "{";
  for (int i = 0; i < (int) ans.size(); i++) {
    cout << ans[i];
    if (i != (int) ans.size() - 1) {
      cout << ", ";
    }
  }
  cout << "}" << endl;
  
  cout << dp[N] << endl;
}
