# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(n, q) = map(int, fi.readline().strip().split())
if 1 > n or n > 2**16:
	sys.exit('N out of range')
if 1 > q or q > 10**5:
	sys.exit('Q out of range')
fo.write('{0} {1}\n'.format(n, q))

for i in range(n):
	a = int(fi.readline().strip())
	if 0 > a or a > 10**9:
		sys.exit('A[{0}] out of range'.format(i))
	fo.write('{0}\n'.format(a))

even = True
odd = True
for i in range(q):
	x = int(fi.readline().strip())
	if 0 > x or x >= 2**16:
		sys.exit('X[{0}] out of range'.format(i))
	if x & 1 == 0:
		odd = False
	if x & 1 == 1:
		even = False
	fo.write('{0}\n'.format(x))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 1024 and q <= 1000:
		print('subtask 1')
	elif n <= 1024:
		print('subtask 2')
	elif even:
		print('subtask 3')
	elif odd:
		print('subtask 4')
	else:
		print('subtask 5')
