# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(n, m) = map(int, fi.readline().strip().split())
if 1 > n or n > 10**5:
	sys.exit('N out of range')
if 1 > m or m > 10**5:
	sys.exit('M out of range')
fo.write('{0} {1}\n'.format(n, m))

c = [0 for _ in range(n)]
for i in range(m):
	(a, b, u) = map(int, fi.readline().strip().split())
	if 1 > a or a > n:
		sys.exit('I[{0}] out of range'.format(1 + i))
	c[a - 1] += 1
	if 1 > b or b > n:
		sys.exit('J[{0}] out of range'.format(1 + i))
	c[b - 1] += 1
	if -500000 > u or u > 500000:
		sys.exit('U[{0}] out of range'.format(1 + i))
	fo.write('{0} {1} {2}\n'.format(a, b, u))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 100 and m <= 1000:
		print('subtask 1')
	elif min(c) >= 1 and max(c) <= 2:
		print('subtask 2')
	else:
		print('subtask 3')
